/*
 * Infomation Button Class
 *
 * 2005/11/11 created by xcatsan@mac.com
 *
 * sample:
 *
 * (in html)
 *	<div class="info_button" id="info_rollie"></div>
 *	<div class="info_button" id="info_i"
 *		onclick="showBack(event);"
 *		onmouseover="infoButton.enter(event);"
 *		onmouseout="infoButton.exit(event);"></div>
 *
 * (in onLoad event handler)
 *	infoButton  = new InfoButtonAnimator("info_i" , "info_rollie");
 *
 * (in mousemove event handler)
 *	infoButton.fadeIn();
 *
 * (in mouseout event handler)
 *	infoButton.fadeOut();
 *
 */
InfoButtonAnimator._ANIMATORS = new Array();
function InfoButtonAnimator(button_i, button_rollie) {

	// initialize class variable

	// initialize instance variable
	this.duration      = 700;     // animation duration [ms]
	this.startTime     = 0;
	this.toOpacity     = 1.0;
	this.nowOpacity    = 0.0;
	this.fromOpacity   = 0.0;
	this.timer         = null
	this.frameRate     = 13;
	this.maxOpacity    = 0.4;
	this.button_i      = document.getElementById(button_i);
	this.button_rollie = document.getElementById(button_rollie);

	this.isShown     = false;
	InfoButtonAnimator._ANIMATORS[this.button_i.id] = this;

	// methods

	this.animate = function() {

		var elapsed = (new Date).getTime() - this.startTime;
		if (elapsed > this.duration) {
			elapsed = this.duration;
		}

		if (elapsed >= this.duration) {
			clearInterval(this.timer);
			this.timer = null;
			this.nowOpacity = this.toOpacity;

		} else {
			var scale =
				0.5 * (1 - Math.cos(Math.PI * elapsed / this.duration));
			this.nowOpacity = this.fromOpacity +
				(this.toOpacity - this.fromOpacity) * scale;
		}
		this.button_i.style.opacity = this.nowOpacity;
	}

	this.fade = function(isFadeIn) {
		if (this.timer != null) {
			clearInterval(this.timer);
			this.timer = null;
		}
		this.startTime = (new Date).getTime() - this.frameRate;
		this.timer = setInterval(
			"InfoButtonAnimator._ANIMATORS['" +this.button_i.id+ "'].animate();",
			this.frameRate);
		this.fromOpacity = this.nowOpacity;
		this.toOpacity = isFadeIn ? this.maxOpacity : 0.0;
		this.animate();
	}

	this.fadeIn = function() {
		if (!this.isShown) {
			this.fade(true);
			this.isShown = true;
		}
	}

	this.fadeOut = function() {
		if (this.isShown) {
			this.fade(false);
			this.isShown = false;
		}
	}

	this.enter = function(event) {
		this.button_rollie.style.display = "block";
	}
	this.exit = function(event) {
		this.button_rollie.style.display = "none";
	}

	this.clearRollie = function() {
		this.button_rollie.style.display = "none";
	}

}

