// This file was generated by Dashcode from Apple Inc.
// You may edit this file to customize your Dashboard widget.

//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
    setupParts();
	initCounts();
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    // widget.setPreferenceForKey(null, createInstancePreferenceKey("your-key"));
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    // Restart any timers that were stopped on hide
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    // instancePreferenceValue = widget.preferenceForKey(null, createInstancePreferenceKey("your-key"));
    //
    // Or this for global key's value:
    // globalPreferenceValue = widget.preferenceForKey(null, "your-key");
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}

var candidates = Array();
candidates['dem'] = "Obama";
candidates['gop'] = "McCain";
candidates['tie'] = "Up for Grabs";
var totals = Array();

function initCounts()
{
    for( type in candidates )
    {
        totals[type] = 0;
        document.getElementById(type+'tot').innerHTML = candidates[type] + ": 0";
    }

    var cells = document.getElementsByTagName("td"); 
    for(var i = 0; i < cells.length; i++)
    { 
        var type = cells[i].className;
        if( ! candidates[type] )
            continue;
        var flds = cells[i].innerHTML.match(/\s*([A-Z][A-Z])\s*\((\d+)\)\s*/);
        if( flds == null )
        {
            alert("Internal Error! Could not find state info using: " + cells[i].innerHTML);
            return;
        }
        totals[type] += eval(flds[2]);
        document.getElementById(type+'tot').innerHTML = candidates[type] + ": " + totals[type];
    }
}

function change(el)
{
    type = el.className;

    var flag    = false;
    var next    = "";
    for( type in candidates )
    {
        if( next == "" )
            next = type;

        if( flag )
        {
            next = type;
            break;
        }

        if( type == el.className )
            flag = true;
    }

    if( !flag )
    {
        alert("Internal error! Strange candidate type: " + el.className);
        return;
    }

    el.className = next;
    initCounts();
}

