//------------------------------------------------------------------------------------------- 
//
// Copyright � 1990-2007 by Imaginova Corp, Inc., All rights reserved.
//
// Contains:	Starry Night Dashboard Widget's common code:
//
// Author:		Ivan Pinzon
//
// Date			Initials	Version		Comments
// ----------	---------	----------	---------------------------
// 2007/06/19	IPA			1.0			New
//
//------------------------------------------------------------------------------------------- 

/*
	Status:

*/

// ----------------------------------------------------------------------------------------
// 										Constants:
// ----------------------------------------------------------------------------------------
var kWidthValue = "420";
var kHeightValue = "262";
var kDefaultAlt = 15;
var kDefaultAboveAlt = -90;
var kDefaultFOV = 90.0;
var kAboveElevation = 3000000;
var kHourMs = 1000*3600;
var kSurfaceState = 0;
var kAboveState = 1;

var kMaxFOV = 90.0; // degrees
var kMinFOV = 0.05; // degrees

var kAm = 0;
var kPm = 1;

var kYES = "Yes";
var kNO = "No";

var kBackHeight = 310;

var kFadeInOut = 6;

// azimuth options popup
var kNorthIndex = 0;
var kWestIndex = 1;
var kSouthIndex = 2;
var kEastIndex = 3;
var kFullSkyIndex = 4;

// element IDs
var kWidgetTitleFrontElemID = "widgetTitleFront";
var kLocationFrontElemID = "locationFront";
var kDateStatusElemID = "dateStatusFront";
var kLocationStatusElemID = "locationStatusFront";
var kGazeStatusElemID = "gazeStatusFront";
var kCubeCompositionDivID = "cubeCompositionDiv";
var kCubeCompositionElemID = "cubeComposition";
var kCoreImageCompositionDivID = "coreImageCompositionDiv";
var kCoreImageCompositionElemID = "coreImageComposition";
var kJSBackgroundElemID = "loadingFront";
var kJSSkyChart1ElemID = "skyImage1";
var kJSSkyChart2ElemID = "skyImage2";
var kLogoCompositionElemID = "logoComposition";

// tab views (back)
var kAboutTabView = 0;
var kLocationTabView = 1;
var kOptionsTabView = 2;
var kHelpTabView = 3;
var kTabsCount = kHelpTabView;

var kEpsilon = 0.0001;

var gFadeTitleIn = false;

var kMonthNames = new Array(12);
kMonthNames[0]="January";
kMonthNames[1]="February";
kMonthNames[2]="March";
kMonthNames[3]="April";
kMonthNames[4]="May";
kMonthNames[5]="June";
kMonthNames[6]="July";
kMonthNames[7]="August";
kMonthNames[8]="September";
kMonthNames[9]="October";
kMonthNames[10]="November";
kMonthNames[11]="December";

var kMonthLength = new Array(31,28,31,30,31,30,31,31,30,31,30,31);




// ----------------------------------------------------------------------------------------
// 										Global variables:
// ----------------------------------------------------------------------------------------
// hbx
var _acct = "DM5310155MZA92EN3"; // IPA: added this so it works for the dashboard widget


//mouseWheel
var gMouseWheelTimeout = null;
var gMouseTmpFOV = kMaxFOV;
// buttons:
var gInfoButton;
var gMiniChartButton;
var gSNWebButton;
var gZoomSlider = null;
var gCurrentTime = true;
var glassDoneButton;
var glassFindPostalCodeButton;

// http requests
var gRSSFeedURLHttpRequest = false;
var gRSSFeedHttpRequest = false;
var gMiniChartHttpRequest = null;
var gGetNearestCityHttpRequest = false;
var gFindPostalCodeHttpRequest = false;

var gMiniChartRequestError = false; 

var gElevationState = kSurfaceState;

var gPostalFound = true;
var gPostalValidated = false;
var gLatLongValidated = false;

var gSituation = new SNWEB.SNSituation();
var gCurrentLocation = "";

var gCanZoom = true;

// prefs
var gUserLocationPref = "";

var gAzimuthOptionsIndexPref = 1;
var gTimeZonePref;
var gCurrentTabPref = 0;

// drawer
var gSetupWasCalled = false;
var gIsCollapsed = true;

var gUseChart2 = true;
var gOldImage1Count = 0;
var gOldImage2Count = 0;

// refresh timer
var gRefreshTimer = null;
var gRefreshPeriod = 900; // in secs

// scriptaculous effects, so that I can cancel an effect in progress
var gFadeOutEffect = null;

// ticker timer
var gTicker = null;
// ticker last refresh
var gTickerLastDate =  new Date();

var gTimezoneDate = new Date();
var gTabImagesA = new Array();
var gTabONImagesA = new Array();

var gDisabledControls= false;
var kAdUrl = "http://www.space.com/snserver/ads/dashWidgetAds.js";
//ads
//poll adInfo file every hour

var originalRefreshImage = SNWEBVIEW.refreshImage.bind(SNWEBVIEW);
SNWEBVIEW.refreshImage= function()
		{
			originalRefreshImage();
			refreshSituationStatus();
		}

// Google's geocoder
var attributes = {
	googleMapsKey: 'ABQIAAAAoQ4lnyMvc4oktrxHN0ct1BTzGZlIn362LM7iTtnTgHadZlwVFxTXhDqT1uWatKWx1fNkRr9PkGKwkg',
    initialAddress: 'Toronto Canada'
};


// Dynamically load the Maps API with the specified developer key
if (attributes.googleMapsKey && attributes.googleMapsKey.length) {
    document.write('<' + 'script type="text/javascript" src="http://maps.google.com/maps?file=api&v=2&key=' + attributes.googleMapsKey + '"><' + '/script>');
}

var gGeocoder = null;

if (window.widget)
{
    widget.onshow = onShow;
    widget.onhide = onHide;
}
function captureFrameClick(inEvt){
	var loc = $("adFrame").contentDocument.links[0].href;
	if(window.widget){
		widget.openURL(loc);
	}
	

}
function cBeforeAdShow(){
	
		$("adClick").style.display = "block";
}
function cAfterAdHide(){
	$("adClick").style.display = "none";
	var evObj = document.createEvent("MouseEvents");
}

// onShow() is called when:
// - widget is installed (first run)
// - dashboard is activated
// Note: it's NOT called when the widget is refreshed (cmd-r)
// ----------------------------------------------------------------------------------------
//
// 											Functions:
//
// ----------------------------------------------------------------------------------------



function onShow()
{
	// restart processing ONLY if the front is shown
	var front = document.getElementById("front");
	if (front != null && front.style.display != "none")
	{	
		refreshSituationStatus();
		
		if (!gSetupWasCalled)
		{
			// update the minichart if drawer is open
			
			// request ad control parameters from server  after alotted time.
			if(SNWEBVIEW.advert.adCfgFile){
				SNWEBVIEW.advert.requestAdvertCfg();
			}
			sendMiniChartRequest();
		}
		
		gSetupWasCalled = false;
		
		// refresh RSS feed or just restart ticker
		var showDate = new Date(); // milliseconds
		var oneHour = 1000*3600;
		var elapsedTime = (showDate - gTickerLastDate) / oneHour;
		var tickerElem = document.getElementById("TICKER");
		if (tickerElem != null)
		{
			if ((document.getElementById("TICKER").innerHTML.length == 0) || (elapsedTime > 1))
			{
				// get the RSS feed URL async. The callback will start the ticker.
				gRSSFeedURLHttpRequest = SNWEB.getWidgetRSSFeedURL(getRSSFeedXMLCallback);
				gTickerLastDate = showDate;
			}
			else
			{
				startTickerTimer();
			}
		}
	
		// start an update timer
		if (gRefreshTimer == null)
		{
			gRefreshTimer = setInterval("sendMiniChartRequest();", 1000 * gRefreshPeriod);
		}
		
		// restart the ticker timer
		if (tickerElem != null && gTicker == null)
		{
			gTicker = setTimeout("Ticker_tick();", 30);
		}
		
	}
}


function onHide()
{
	// stop processing ONLY if the front is shown
	var front = document.getElementById("front");
	if (front != null && front.style.display != "none")
	{
		// stop the update timer
		if (gRefreshTimer != null)
		{
			clearInterval(gRefreshTimer);
			gRefreshTimer = null;
		}
		
		// stop the ticker timer
		if (gTicker != null)
		{
			clearTimeout(gTicker);
			gTicker = null;
		}
	
	}
}


function resetRefreshTimer()
{
    if (gRefreshTimer != null)
	{
        clearInterval(gRefreshTimer);
	}
	gRefreshTimer = setInterval("sendMiniChartRequest();", 1000 * gRefreshPeriod);
}

function restoreGaze()
{
	if (window.widget)
	{
		setAzimuth(gAzimuthOptionsIndexPref);
		if (gElevationState == kSurfaceState)
		{
			SNWEBVIEW.situation.gaze.alt = kDefaultAlt;
			SNWEBVIEW.zoomSlider.setValue(kDefaultFOV);
		}

	}
}

function getZoomStep()
{
	var currentFOV = SNWEBVIEW.situation.gaze.FOV;
	var zoomStep = 15;
	if (currentFOV < 45)
	{
		zoomStep = 10;
		if (currentFOV < 30)
		{
			zoomStep = 5;
			if (currentFOV < 15)
			{
				zoomStep = 3;
				if (currentFOV < 5)
				{
					zoomStep = 1;
					if (currentFOV < 2)
					{
						zoomStep = 0.5;
						if (currentFOV < 1)
						{
							zoomStep = 0.1;
						}
					}
				}
			}
		}
	}
	
	return zoomStep;
}

function goToStarryNight(event)
{
	if (window.widget)
	{
		widget.openURL("http://store.yahoo.com/cgi-bin/clink?yhst-49664100110157+58wNhQ+stniso.html");
	}
}

function goToDigitalDownload(event)
{
	if (window.widget)
	{
		widget.openURL("http://store.yahoo.com/cgi-bin/clink?yhst-49664100110157+58wNhQ+digitaldownload.html");
	}
}

function goToImaginova(event)
{
	if (window.widget)
	{
		widget.openURL("http://www.imaginova.com");
	}
}

function goToStarryNightServer(event)
{
	if (window.widget)
	{
		var url = SNWEB.getRedirectURL({situ: SNWEBVIEW.situation});
		widget.openURL(url);

		// hbx
		SNWEB.trackAction({action: SNWEB.consts.kTrack_openWebAppClicked});
	}
}


// ----------------------------------------------------------------------------------------
//
// 											RSS feed in a scrolling ticker tape:
//
// ----------------------------------------------------------------------------------------

// RSS feed URL callback. Once it has the URL, get the XML from it.
function getRSSFeedXMLCallback()
{
	if (gRSSFeedURLHttpRequest != null && gRSSFeedURLHttpRequest.readyState == 4)
	{
		if (gRSSFeedURLHttpRequest.status == 200)
		{
			// get the URL
			var rssURL = SNWEB.parseRSSXML(gRSSFeedURLHttpRequest.responseXML);

			// now get the feed XML
			gRSSFeedHttpRequest = new XMLHttpRequest();
			gRSSFeedHttpRequest.onreadystatechange = RSSFeedXMLCallback;
			gRSSFeedHttpRequest.overrideMimeType("text/xml");
			gRSSFeedHttpRequest.open("GET", rssURL, true);
			gRSSFeedHttpRequest.setRequestHeader("Cache-Control", "no-cache");
			gRSSFeedHttpRequest.send(null);
		}
	}
	
}

// RSS feed callback. Once it has the XML, start the ticker.
function RSSFeedXMLCallback()
{
	if (gRSSFeedHttpRequest!= null && gRSSFeedHttpRequest.responseXML)
	{
		if (gRSSFeedHttpRequest.readyState == 4)
		{
			if (gRSSFeedHttpRequest.status == 200)
			{
				try
				{
					var rss = findChild(gRSSFeedHttpRequest.responseXML, 'rss');
					var channel = findChild(rss, 'channel');
					if (channel != null)
					{
						var i = 0;
						var html = "";
						for (var child = channel.firstChild; child != null; child = child.nextSibling)
						{
							if (child.nodeName == 'item')
							{
								var title = findChild(child, 'title');
								var link = findChild(child, 'link');
//								var description = findChild(child, 'description');
								i++;

								html += "...  "
//								 + "<a href='#' onclick=\"widget.openURL('" + link.firstChild.data + "'); trackAction(" + kWidgetID + ",'" + kDashboardWidgetVersion + "'," + kTrack_tickerLinkClicked + ", false,'" + link.firstChild.data +"');\">"
								 + "<a href='#' onclick=\"widget.openURL('" + link.firstChild.data + "'); SNWEB.trackAction({action:" + SNWEB.consts.kTrack_tickerLinkClicked + ",isError: false, data:'" + link.firstChild.data +"'});\">"
								 + title.firstChild.data
								 + "</a> ";

								if (i > SNWEB.consts.kNumberOfRSSFeedEntriesToUse)
								{
									break;
								}
							}					
						}
					}
				}
				catch (ex)
				{
					alert("XML parsing exception");
				}
				
				// start the ticker
				document.getElementById("TICKER").innerHTML = html;
				ticker_start();
			}
			else if (gRSSFeedHttpRequest.status == 404)
			{
				alert("URL doesn't exist");
			}
			else
			{
				alert("There was a problem with the RSS Feed request: " + gRSSFeedHttpRequest.status);
				alert(gRSSFeedHttpRequest.statusText);

				var html = " ... Can't connect to server ...";
				// start the ticker
				document.getElementById("TICKER").innerHTML = html;
				ticker_start();
			}
		}
	}
}

function findChild(inElement, inNodeName)
{
	var aChild;
	
	for (aChild = inElement.firstChild;   aChild != null;   aChild = aChild.nextSibling)
	{
		if (aChild.nodeName == inNodeName)
			return aChild;
	}
	
	return null;
}

var TICKER_CONTENT = "";
 
var TICKER_RIGHTTOLEFT = false;
var TICKER_SPEED = 1;
var TICKER_STYLE = "font-family:Lucida Grande; font-size:13px; color:white";
var TICKER_PAUSED = false;
var gTickerScrollPos = 0;

function ticker_start()
{
	TICKER_CONTENT = document.getElementById("TICKER").innerHTML;
	TICKER_WIDTH = document.getElementById("TICKER").clientWidth;
	var img = "<img src=ticker_space.gif width="+TICKER_WIDTH+" height=0>";

	document.getElementById("TICKER").innerHTML = "<TABLE  cellspacing='0' cellpadding='0' width='100%'><TR><TD nowrap='nowrap'>"+img+"<SPAN style='"+TICKER_STYLE+"' ID='TICKER_BODY' width='100%'>&nbsp;</SPAN>"+img+"</TD></TR></TABLE>";

	document.getElementById("TICKER").scrollLeft = TICKER_RIGHTTOLEFT ? document.getElementById("TICKER").scrollWidth - document.getElementById("TICKER").offsetWidth : 0;
	document.getElementById("TICKER_BODY").innerHTML = TICKER_CONTENT;
	document.getElementById("TICKER").style.display="block";

	startTickerTimer();
}

function startTickerTimer()
{
    // stop the ticker timer
    if (gTicker != null)
    {
    	clearTimeout(gTicker);
    	gTicker = null;
    }

	Ticker_tick();
}

function Ticker_tick()
{
	if(!TICKER_PAUSED) document.getElementById("TICKER").scrollLeft += TICKER_SPEED * (TICKER_RIGHTTOLEFT ? -1 : 1);
	if(TICKER_RIGHTTOLEFT && document.getElementById("TICKER").scrollLeft <= 0) document.getElementById("TICKER").scrollLeft = document.getElementById("TICKER").scrollWidth - document.getElementById("TICKER").offsetWidth;
	if(!TICKER_RIGHTTOLEFT && document.getElementById("TICKER").scrollLeft >= document.getElementById("TICKER").scrollWidth - document.getElementById("TICKER").offsetWidth) document.getElementById("TICKER").scrollLeft = 0;
	gTicker = setTimeout("Ticker_tick()", 30);
}

function saveTickerScroll()
{
	gTickerScrollPos = document.getElementById("TICKER").scrollLeft;
}

function restoreTickerScroll()
{
	document.getElementById("TICKER").scrollLeft = gTickerScrollPos;
}

// ----------------------------------------------------------------------------------------
//
// 											Server stuff:
//
// ----------------------------------------------------------------------------------------

// ----------------------------------------------------------------------------------------
//	Find nearest city from lat/long
// ----------------------------------------------------------------------------------------

function latLongTyping (event)
{
	// validate lat/long
	var latitude = document.getElementById("latitudeField").value;
	var longitude = document.getElementById("longitudeField").value;
	if (latitude == '-')
	{
		latitude = '0';
	}
	if (longitude == '-')
	{
		longitude = '0';
	}

	if (!isNaN(latitude) && !isNaN(longitude))
	{
		gLatLongValidated = false;
		var s = latitude + " / " + longitude;
		setElementByIdInnerText("locationBack", s);
		setElementByIdValue("postalCodeField", "");
		postLatLongTyping();
	}
	else
	{
//		_sound.beep();
		document.getElementById("latitudeField").value = SNWEBVIEW.situation.location.lat;
		document.getElementById("longitudeField").value = SNWEBVIEW.situation.location.lng;
	}
}


function latLongKeyPress (event)
{
	switch (event.keyCode)
	{
		case 13: // return
		case 3:  // enter
		case 9:  // tab
			if (!gLatLongValidated)
			{
				// get the latitude
				SNWEBVIEW.situation.location.lat = document.getElementById("latitudeField").value;
				// get the longitude
				SNWEBVIEW.situation.location.lng = document.getElementById("longitudeField").value;

				findNearestCity();
			}
			break;
	}
}

function locationKeyPress (event)
{
	switch (event.keyCode)
	{
		case 13: // return
		case 3:  // enter
		case 9:  // tab
				// get the latitude
				findNearestCityGoogle();
			break;
	}
}

function findNearestCityGoogle()
{
	if (window.widget)
	{
		// get the postal code
		var locationElement = document.getElementById("locationField");

		if (locationElement && locationElement.value.length > 0)
		{
			// clean the postal code
			var location = locationElement.value;
			if(gGeocoder){
					gGeocoder.getLatLng(location, function (latLongPoint) {
					// when we get the result, send a request to SN Server to get the timezone
					if (latLongPoint)
					{
						// get the latitude
						SNWEBVIEW.situation.location.lat = latLongPoint.lat();
						// get the longitude
						SNWEBVIEW.situation.location.lng = latLongPoint.lng();
	
						findNearestCity();
					}
				});
			}
		}
	}
}

function findNearestCity()
{
	if (window.widget)
	{
		var saveElevation = SNWEBVIEW.situation.location.elevation;
		SNWEBVIEW.situation.location.elevation = SNWEB.consts.kDefaultElevation;
		
		var url = SNWEB.getRequestURL({	type:	SNWEB.consts.kGetNearestCityRequest,
												situ:		SNWEBVIEW.situation});

		SNWEBVIEW.situation.location.elevation = saveElevation;
		
		// create an HTTP request to SNServer: get the lat/long for the given postal code
		gGetNearestCityHttpRequest = new XMLHttpRequest();
		if (gGetNearestCityHttpRequest.overrideMimeType)
		{
			gGetNearestCityHttpRequest.overrideMimeType('text/xml');
		}
		
		// set the BACK location caption to "Searching..."
		document.getElementById("locationBack").innerText = "Searching...";

		// send the request: ASYNC
		gGetNearestCityHttpRequest.onreadystatechange = nearestCityCallback;
		gGetNearestCityHttpRequest.open('GET', url, true);
		gGetNearestCityHttpRequest.setRequestHeader("Cache-Control", "no-cache");
		gGetNearestCityHttpRequest.send(null);
		gLatLongValidated = false;
		
		// widget specific stuff
		preFindNearestCity();
	}
}

function nearestCityCallback()
{
	if (gGetNearestCityHttpRequest.readyState == 4)
	{
		if (gGetNearestCityHttpRequest.status == 200)
		{
			var replyFields = new Array();
			replyFields = gGetNearestCityHttpRequest.responseText.split('|');
			document.getElementById("locationBack").innerText = replyFields[0];
			document.getElementById(kLocationFrontElemID).innerText = replyFields[0];
			
			//only change to default gaze when location was changed
			if( gUserLocationPref != replyFields[0]){
				restoreGaze();
			}
			
			gUserLocationPref = replyFields[0];
			SNWEBVIEW.situation.location.timezone = replyFields[1];
			
			gLatLongValidated = true;
//			savePrefs();
			
			// widget specific stuff
			postFindNearestCity();

			SNWEB.trackAction({action: SNWEB.consts.kTrack_NearestCityRequest});
		}
		else if (gGetNearestCityHttpRequest.status == 404)
		{
			alert("URL doesn't exist");
			SNWEB.trackAction({action: SNWEB.consts.kTrack_NearestCityRequest, isError: true, data: "URL doesn't exist"});
		}
		else
		{
			alert("There was a problem with the Nearest City request: " + gGetNearestCityHttpRequest.status);
			alert(gGetNearestCityHttpRequest.statusText);
			SNWEB.trackAction({action: SNWEB.consts.kTrack_NearestCityRequest, isError: true, data: "There was a problem with the Nearest City request: "});
		}
	}
}

// ----------------------------------------------------------------------------------------
//	Small chart in drawer
// ----------------------------------------------------------------------------------------


var gComposition = {showLoading:true, canProcessRequests:true, startTime:0, time:0, startValue:0, endValue:0, duration:1, timer:null, timeout:null, onFinished:null};

function handleChartDrawer(event)
{	
	if (window.widget)
	{
		if (!gIsCollapsed)
		{
				document.getElementById(kLocationFrontElemID).innerText = kWidgetTitle;
				document.getElementById("middle").style.display == "none";
				
		}
		else
		{
	
			document.getElementById(kLocationFrontElemID).innerText = gUserLocationPref;			
			//setWidgetTitle();

		}
		toggleView(); // this toggles gIsCollapsed
		setInfoButtonStyle();
		// send the request
		setTimeout(sendMiniChartRequest, 1000);
	}
}

function sendMiniChartRequest()
{
	if (!gIsCollapsed) {
		document.getElementById("statusFront").innerText = "";
		
		if(gCurrentTime){
			SNWEBVIEW.situation.dateTime.setTime(new Date());
		}
		SNWEBVIEW.refreshImage();
		}
	else
	{
		document.getElementById("statusFront").innerText = "";
	}
}

// ----------------------------------------------------------------------------------------
// Core Image transition functions
// ----------------------------------------------------------------------------------------

// ----------------------------------------------------------------------------------------
//
//												Controller:
//
// ----------------------------------------------------------------------------------------

function populateAzimuthOptions()
{
	var select = document.getElementById ('azimuthOptions');
	var element;
	
	if (select != null)
	{
		element = document.createElement ("option");
		element.innerText = "North";
		select.appendChild(element);
		element = document.createElement ("option");
		element.innerText = "West";
		select.appendChild(element);
		element = document.createElement ("option");
		element.innerText = "South";
		select.appendChild(element);
		element = document.createElement ("option");
		element.innerText = "East";
		select.appendChild(element);
	}
}

function azimuthChanged(select)
{
	gAzimuthOptionsIndexPref = select.selectedIndex;
	setAzimuth(gAzimuthOptionsIndexPref);
}




// Utility to find the porsition of an element.
// Use:
// var pos = findPos(myDiv);
// alert(pos[0] + pos[1]);

function findPos(obj) {
	var curleft = curtop = 0;
	if (obj.offsetParent) {
		curleft = obj.offsetLeft;
		curtop = obj.offsetTop;
		while (obj = obj.offsetParent) {
			curleft += obj.offsetLeft;
			curtop += obj.offsetTop;
		}
	}
	return [curleft,curtop];
}



function updateWidgetTitle()
{
	var divToFadeIn = null;
	var divToFadeOut = null;
	
	if (gFadeTitleIn)
	{
		divToFadeIn = kLocationFrontElemID;
		divToFadeOut = kWidgetTitleFrontElemID;
	}
	else
	{
		divToFadeIn = kWidgetTitleFrontElemID;
		divToFadeOut = kLocationFrontElemID;
	}
	gFadeTitleIn = !gFadeTitleIn;

	Effect.Fade(divToFadeOut, { duration:0.8, to:0.0 });
	Effect.Appear(divToFadeIn, { duration:0.8, to:1.1 });
}


function getTimezoneDate(dateObj){
	if (dateObj == null){
		dateObj = new Date();
	}
	localTime = dateObj.getTime();
	localOffset = dateObj.getTimezoneOffset()*60000;
	utc = localTime+localOffset;
	newTime = utc+(3600000*24*SNWEBVIEW.situation.location.timezone);
	timeOfDay = new Date(newTime);
	return timeOfDay;
}

function refreshSituationStatus()
{
	var lat = 0.0;
	var lng = 0.0;
	var locationStr = "";
	var gazeStr = "";
	var timeString = "";
	var latchZero = function(num){ return ( num < 10) ? "0"+ num : num;  };
	
	if (SNWEB.platform == SNWEB.consts.kBSW_Dashboard)
	{
		document.getElementById(kDateStatusElemID).innerText = SNWEBVIEW.situation.dateTime.toLocaleString();
		document.getElementById(kLocationStatusElemID).innerText = gUserLocationPref;
	}
	else
	{
		var lat = parseFloat(SNWEBVIEW.situation.location.lat);
		var lng = parseFloat(SNWEBVIEW.situation.location.lng);
		var locationStr = "Lat: " + lat.toFixed(2) + "  Long: " + lng.toFixed(2);
		var gazeStr = "Alt: " + SNWEBVIEW.situation.gaze.alt.toFixed(1) + "  Az: " + SNWEBVIEW.situation.gaze.az.toFixed(1) + "  FOV: " + SNWEBVIEW.situation.gaze.FOV.toFixed(1);
		if (SNWEB.platform == SNWEB.consts.kMEW_Dashboard)
		{
			document.getElementById(kDateStatusElemID).innerText = SNWEBVIEW.situation.dateTime.toUTCString();
		}
		else
		{
			
			var time = (gCurrentTime) ? getTimezoneDate(SNWEBVIEW.situation.dateTime) : (SNWEBVIEW.situation.dateTime) ;
			var timezone = (SNWEBVIEW.situation.location.timezone*24).toFixed(2);
			var hours = time.getHours();
			var minutes = time.getMinutes();
			var seconds = time.getSeconds();
			var offset = 0;
			var sign = "+";
			var GMTHour = 0;
			if (timezone.charAt(0) == "-"){
					sign = "-";
					offset =0;
					GMTHour = timezone.substr(1, (timezone.indexOf(".") - 1) );
			}
			else{
				GMTHour =  timezone.substr(0, (timezone.indexOf(".")) );
			}
			
			GMTHour = latchZero(GMTHour);
				
			var GMTMinutes=timezone.substr((timezone.indexOf(".")+1),(timezone.length-1));
			// GMTMinutes =  (GMTMinutes == 0 ) ? "00" : (GMTMinutes*60).toFixed(0);

			timezone = sign + GMTHour + "." + GMTMinutes;
			hours = latchZero(hours);
			minutes = latchZero(minutes);
			seconds = latchZero(seconds);
			var timeString = kMonthNames[ time.getMonth() ] +" " +time.getDate() + ", " + time.getFullYear() +"  "+ hours+":"+ minutes+":"+ seconds +"  GMT   " + timezone; 
			if (SNWEBVIEW.situation.location.useDST)
			{
				
				timeString += " (DST)";
			}
			document.getElementById(kDateStatusElemID).innerText = timeString;
		}
		document.getElementById(kLocationStatusElemID).innerText = locationStr;
		document.getElementById(kGazeStatusElemID).innerText = gazeStr;
	}
}


// ----------------------------------------------------------------------------------------
//
//												Preferences:
//
// ----------------------------------------------------------------------------------------

//----------------------------------------------------------------------
//	gCurrentTime() is called when the preferences flipper is clicked upon.  It freezes the front of the widget,
//	hides the front div, unhides the back div, and then flips the widget over.
//----------------------------------------------------------------------

function showPrefs()
{
	onHide();
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	var tickerElem=document.getElementById("TICKER");
    if(tickerElem!=null)
    {
        saveTickerScroll();
    }

	if (window.widget)
	{
		if (gIsCollapsed)
		{
			// have to resize first, if collapsed
			// resize window to full size so that prefs show complete
			window.resizeTo (kMaxWidgetWidth, kBackHeight);
		}
		if(gTicker){
			saveTickerScroll();
		}
		Event.stopObserving(window.document,"keypress");	
		widget.prepareForTransition("ToBack");		// freezes the widget so that you can change it without the user noticing
	}
 
	
	front.style.display="none";		// hide the front
	back.style.display="block";		// show the back
	
	if (window.widget)
	{
		setTimeout ('widget.performTransition();', 0);		// and flip the widget over	

		// resize window to full size so that prefs show complete
		window.resizeTo (kMaxWidgetWidth, kBackHeight);
	}


	// reload the UI in case an aync response was received in the "front" state
	loadPrefsUI();
	
}




function resizeWindowForPrefs()
{
	if (window.widget)
	{
		var elemStyle = document.defaultView.getComputedStyle(divider, "");
		var topHeight = parseInt(elemStyle.getPropertyValue("top"));

		var currentTabViewHeight = document.getElementById("tabDiv" + gCurrentTabPref).clientHeight;

		var elemStyle = document.defaultView.getComputedStyle(divider2, "");
		var bottomHeight = parseInt(elemStyle.getPropertyValue("bottom"));

		var wH = topHeight + currentTabViewHeight + bottomHeight;

		window.resizeTo (kMaxWidgetWidth, wH);
	}
}

//----------------------------------------------------------------------
// Select tab: hide old / show new
//----------------------------------------------------------------------

function selectTab(inWhichTab)
{
	if (gCurrentTabPref != inWhichTab)
	{
		// save wahtever prefs are in this tab view before hiding it, otherwise getElementById will return null
		savePrefsFromUI();

		var currentTabView = document.getElementById("tabDiv" + gCurrentTabPref);
		var newTabView = document.getElementById("tabDiv" + inWhichTab);

		Effect.Fade(currentTabView, { duration:0.2, to:0.0 });
		Effect.Appear(newTabView, { duration:0.2, to:1.1});

		var oldTab = gCurrentTabPref;
		gCurrentTabPref = inWhichTab;
		
		setTabImage("tabImg"+gCurrentTabPref, gCurrentTabPref, true);
		setTabImage("tabImg"+oldTab, oldTab, false);
		
		// set the z-Index of the new tab view higher so that it is on top of the others
		currentTabView.style.zIndex = 999;
		newTabView.style.zIndex = 1000;
		

	}
}

//----------------------------------------------------------------------
// Preload tab images
//----------------------------------------------------------------------

function loadTabImages(inImage, inImageON, inIndex)
{
	var img = new Image;
	img.src = inImage;
	gTabImagesA[inIndex] = img;
	
	img = new Image;
	img.src = inImageON;
	gTabONImagesA[inIndex] = img;	
}

function setTabImage(inElem, inImageIndex, inTurnON)
{
	if (inElem)
	{
		var elem = document.getElementById(inElem);
		if (elem)
		{
			if (inTurnON)
			{
				elem.src = gTabONImagesA[inImageIndex].src;
			}
			else
			{
				if (gCurrentTabPref != inImageIndex)
				{
					elem.src = gTabImagesA[inImageIndex].src;
				}
			}
		}
	}
}



function setPreference(inPref, inDefaultValue)
{
	var result = inDefaultValue;
	if (inPref != "undefined")
	{
		if ((typeof(inPref) == "string" && inPref.length > 0) || typeof(inPref) == "number")
		{
			result = inPref;
		}
	}

	return result;
}



//----------------------------------------------------------------------
// Prefs utilities
//----------------------------------------------------------------------

function createKey (key)
{
	return widget.identifier + "-" + key;
}

// Just for changing the chkbox state
function changePref(inField, inPref)
{
	var state = document.getElementById(inField).checked ? "Yes" : "No";
}


function setLocalChk(localChk)
{
	// var dateFields= document.getElementById('dateFields');
	
	if(localChk.checked){
		SNWEBVIEW.situation.useTimezoneAndUTC = true;
		gCurrentTime = true;
		// SNWEBVIEW.situation.dateTime.setTime(new Date);
		setDST();
		document.getElementById('monthOptions').disabled = true;
		document.getElementById('dayOptions').disabled = true;
		document.getElementById('yearField').disabled = true;
		document.getElementById('timeOptions').disabled = true;
		document.getElementById('amPmOptions').disabled = true; 
		document.getElementById('useDSTChk').disabled = true;
	}
	else{
		gCurrentTime = false;
		SNWEBVIEW.situation.dateTime.setMinutes(0);
		SNWEBVIEW.situation.dateTime.setSeconds(0);
		SNWEBVIEW.situation.useTimezoneAndUTC = false; 
		//SNWEBVIEW.situation.dateTime.setTime(tmpdate);
		document.getElementById('dayOptions').disabled = false;
		document.getElementById('yearField').disabled = false;
		document.getElementById('timeOptions').disabled = false;
		document.getElementById('amPmOptions').disabled = false;
		document.getElementById('useDSTChk').disabled = false;
		document.getElementById('monthOptions').disabled = false; 
	}	 
}
function showHorizonChk(inField,inPref){
	var element = document.getElementById(inField);
	if(element.checked){
		setDefaultAltitude();
	}
}
function prefLabelClick(inField, inPref)
{
	var element = document.getElementById(inField);
	element.checked = !element.checked;
	changePref(inField, inPref);
}

function setAzimuth(inAzimuthIndex){

	switch(inAzimuthIndex)
	{
		case kNorthIndex: SNWEBVIEW.situation.gaze.az = 0; break;
		case kWestIndex: SNWEBVIEW.situation.gaze.az = 270; break;
		case kSouthIndex: SNWEBVIEW.situation.gaze.az = 180; break;
		case kEastIndex: SNWEBVIEW.situation.gaze.az = 90; break;
	}
}

function setDefaultFOV(){

	SNWEBVIEW.situation.gaze.FOV = (gElevationState == kSurfaceState) ? SNWEB.consts.kDefaultFOV : kDefaultAboveFOV;
	SNWEBVIEW.zoomSlider.setValue(SNWEBVIEW.situation.gaze.FOV);
}

function setDefaultAltitude(){

	SNWEBVIEW.situation.gaze.alt = (gElevationState == kSurfaceState) ? kDefaultAlt : kDefaultAboveAlt;
}

function setDefaultElevation(){

	SNWEBVIEW.situation.location.elevation = (gElevationState == kSurfaceState) ? SNWEB.consts.kDefaultElevation : SNWEB.consts.kAboveElevation;
}

function populateMonthsAndTime(){

	var select = document.getElementById ('monthOptions');
	var element;
	var i = 0;
	
	// months
	for (i = 0; i < kMonthNames.length; i++)
	{
		element = document.createElement ("option");
		element.innerText = kMonthNames[i];
		select.appendChild(element);
	}
	
	// time
	select = document.getElementById ('timeOptions');
	for (i = 1; i <= 12; i++)
	{
		element = document.createElement ("option");
		element.innerText = String(i);
		select.appendChild(element);
	}
	select = document.getElementById ('amPmOptions');
	element = document.createElement ("option");
	element.innerText = "am";
	select.appendChild(element);
	element = document.createElement ("option");
	element.innerText = "pm";
	select.appendChild(element);
}

// ----------------------------------------------------------------------------------------
//	populateDays()
//
//	Purpose:	fills days popup according to year, month
//
//	inYear:		year, 4 digit number
//	inMonth:	month, number, 0 relative
//
//	Date		Initials	Version		Comments
//  ----------	---------	----------	---------------------------
//	2007/07/04	IPA			1.0			New
// ----------------------------------------------------------------------------------------

function populateDays(inYear, inMonth)
{
	var select = document.getElementById ('dayOptions');
	var element;
	var i = 0;

//alert("pop days1 yy-mm: "+ inYear + " " + inMonth + " " +select.length);

	// calculate the number of days in the month
	var month = parseInt(inMonth);
	var monthLength = kMonthLength[parseInt(inMonth)];
	if (month == 1 && (SNWEB.utils.isLeapYear(inYear)) )
	{
		monthLength = 29;
	}

	if (select.length != monthLength)
	{
		// remove all the popup items
		for (i = select.length; i > 0; i--)
		{
			select.remove(i-1);
		}
		
		// add actual number of days for month/year
	
//	alert("pop days2: "+monthLength);
		for (i = 0; i < monthLength; i++)
		{
			element = document.createElement ("option");
			element.innerText = String(i+1);
			select.appendChild(element);
		}
	}
}


function setElementByIdValue(inElement, inValue)
{
	var element = document.getElementById(inElement);
	if (element != null)
	{
		element.value = inValue;
	}
}

function setElementByIdInnerText(inElement, inText)
{
	var element = document.getElementById(inElement);
	if (element != null)
	{
		element.innerText = inText;
	}
}

// ----------------------------------------------------------------------------------------
//
// 										Drawer animation
//
// ----------------------------------------------------------------------------------------

var kTopHeight = 38;
var kSituationStatusHeight = 32;
var kBottomHeight = 31;
var kSidesWidth = 12;

var kMaxImageHeight = 262; 
var kMinImageHeight = 0;
var kMaxImageWidth = 420;

var kMaxWidgetHeight = kTopHeight + kSituationStatusHeight + kMaxImageHeight + kBottomHeight;
var kMaxWidgetWidth = kMaxImageWidth + 2*kSidesWidth;
var kMinWidgetHeight = kTopHeight + kBottomHeight;
var kMinWidgetWidth = kMaxImageWidth + 2*kSidesWidth;

var gResizeAnimation = {startTime:0, duration:kMaxImageHeight, positionFrom:0, positionTo:0, positionNow:0, frameFrom:0, frameTo:0, frameNow:0, timer:null, element:null, image:null, background:null, onfinished:null};


function limit_3(a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat(from, to, ease)
{
    return from + (to - from) * ease;
}

function calculateBackgroundHeight()
{
	// returns the new image (middle) size
	var height;
	if (gIsCollapsed)
		height = kMinImageHeight;
	else
		height = kMaxImageHeight + kSituationStatusHeight;
		
	return height;
}

function animate()
{
	var T;
	var ease;
	var time  = (new Date()).getTime();
	var yLoc;
	var frame;
		
	T = limit_3(time-gResizeAnimation.startTime, 0, gResizeAnimation.duration);
	ease = 0.5 - (0.5 * Math.cos(Math.PI * T / gResizeAnimation.duration));

	if (T >= gResizeAnimation.duration)
	{
		yLoc = gResizeAnimation.positionTo;
		clearInterval (gResizeAnimation.timer);
		gResizeAnimation.timer = null;
		
		if (gResizeAnimation.onfinished)
//			setTimeout ("gResizeAnimation.onfinished();", 0); // call after the last frame is drawn
			setTimeout (gResizeAnimation.onfinished, 0); // call after the last frame is drawn
	}
	else
		yLoc = computeNextFloat(gResizeAnimation.positionFrom, gResizeAnimation.positionTo, ease);
		
	// convert to a integer, not sure if this is the best way
	gResizeAnimation.positionNow = Math.round(yLoc);
	gResizeAnimation.element.style.height = gResizeAnimation.positionNow + "px";
}

function animFinished()
{
	if (window.widget)
	{
		if (gIsCollapsed)
		{			
			
			window.resizeTo (kMaxWidgetWidth, kMinWidgetHeight);
		}
		else
		{

				document.getElementById("middle").style.display = "block";
		}
		
		widget.setPreferenceForKey(gIsCollapsed ? kYES : kNO, kCollapsedKey);
	}
}

function toggleView()
{
	var midDiv = document.getElementById("middle");
	
	var timeNow = (new Date()).getTime();
	//var multiplier = (event.shiftKey ? 10 : 1); // enable slo-mo
	var startingSize = Math.round(midDiv.clientHeight,10);
	
	
	gResizeAnimation.element = midDiv;
	
	if (gResizeAnimation.timer != null) // it is moving... change to new size
	{
		clearInterval(gResizeAnimation.timer);
		gResizeAnimation.timer = null;
		gResizeAnimation.duration -= (timeNow - gResizeAnimation.startTime);
		gResizeAnimation.positionFrom = gResizeAnimation.positionNow;
	}
	else
	{
		gResizeAnimation.duration = kMaxImageHeight;
		gResizeAnimation.positionFrom = startingSize;
	}
	
	gIsCollapsed = !gIsCollapsed;
	 
	var resizeTo = calculateBackgroundHeight();
	if (!gIsCollapsed && window.widget){
	
		window.resizeTo (kMaxWidgetWidth, kMaxWidgetHeight);
		
	}
	
	gResizeAnimation.positionTo = Math.round(resizeTo);
	gResizeAnimation.startTime = timeNow - 13; // set it back one frame.
	gResizeAnimation.onfinished = animFinished;
	gResizeAnimation.element.style.height = startingSize + "px";
	gResizeAnimation.timer = setInterval ("animate();", 13);
	animate();
	
}

// ----------------------------------------------------------------------------------------
// 										That's all folks
// ----------------------------------------------------------------------------------------
